package jtaDiscRack.actions;

import jtaDiscRack.*;

import javax.swing.AbstractAction;
import javax.swing.Action;

/**
* The base class for discRack actions.
 *
 * @author Sasa Bojanic
 * @version 1.0
*/
public abstract class ActionBase
   extends AbstractAction {

   /**
    * A reference to the editor class.
    */
   protected JtaDiscRack jtaDiscRack;

   /**
    * The Abstract action uses unqualified class name as action name.
    *
    * @param editor The reference to the editor for this action
    */
   public ActionBase(JtaDiscRack jtaDiscRack) {
      this.jtaDiscRack = jtaDiscRack;
      putValue(Action.NAME,Utils.getUnqualifiedClassName(getClass()));
   }

}
