package allinone;

import com.lutris.appserver.server.sql.*;
import com.lutris.util.*;
import org.enhydra.dods.*;
import java.sql.SQLException;


import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;
import com.lutris.appserver.server.sql.*;
import allinone.data.tableA.*;
import allinone.data.tableB.*;
import allinone.data.tableC.*;

public class CircusMultiReference {
    void showTables(DBTransaction dbTrans){
        try{
            CRTableAQuery queryA = new CRTableAQuery(dbTrans);
            CRTableADO[] allADO = queryA.getDOArray();
            System.err.println();
            System.err.println("-------------TableA-----begin----------");
            if(allADO!=null) {
                if(allADO.length>0)System.err.println("------oid---------someData--------refToB--------");
                for(int i=0; i<allADO.length; i++){
                    System.err.print("   "+allADO[i].getHandle());
                    System.err.print("   "+allADO[i].getSomedata());
                    if (null != allADO[i].getReftob()) {
                        System.err.print("   "+allADO[i].getReftob().getOId());
                        System.err.print("   "+allADO[i].getReftob().getSomedata());
                        System.err.print("   "+allADO[i].getReftob().getReftoc());
                    }
                    System.err.println();
                }
            } else {
                System.err.println("noData");
            }
            System.err.println("-------------TableA-----end------------");

            CRTableBQuery queryB = new CRTableBQuery(dbTrans);
            CRTableBDO[] allBDO = queryB.getDOArray();
            System.err.println();
            System.err.println("-------------TableB-----begin----------");
            if(allBDO!=null) {
                if(allBDO.length>0)System.err.println("------oid---------someData--------refToC-----");
                for(int i=0; i<allBDO.length; i++){
                    System.err.print("   "+allBDO[i].getHandle());
                    System.err.print("   "+allBDO[i].getSomedata());
                    if (null != allBDO[i].getReftoc()) {
                        System.err.print("   "+allBDO[i].getReftoc().getOId());
                        System.err.print("   "+allBDO[i].getReftoc().getSomedata());
                    }
                    System.err.println();
                }
            } else {
                System.err.println("noData");
            }
            System.err.println("-------------TableB-----end------------");

            CRTableCQuery queryC = new CRTableCQuery(dbTrans);
            CRTableCDO[] allCDO = queryC.getDOArray();
            System.err.println();
            System.err.println("-------------TableC-----begin----------");
            if(allCDO!=null) {
                if(allCDO.length>0)System.err.println("------oid---------someData--------refToA-----");
                for(int i=0; i<allCDO.length; i++){
                    System.err.print("   "+allCDO[i].getHandle());
                    System.err.print("   "+allCDO[i].getSomedata());
                    if (null != allCDO[i].getReftoa()) {
                        System.err.print("   "+allCDO[i].getReftoa().getOId());
                        System.err.print("   "+allCDO[i].getReftoa().getSomedata());
                    }
                    System.err.println();
                }
            } else {
                System.err.println("noData");
            }
            System.err.println("-------------TableC-----end------------");
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    public void runTest(DBTransaction dbTrans1) {
        int maxDOs=9;
        try {
            System.err.println("___ - + * startin CircMultRef * + -  ___");
            showTables(dbTrans1);

            CRTableADO[] arrayOfA =  new  CRTableADO[maxDOs];
            CRTableBDO[] arrayOfB =  new  CRTableBDO[maxDOs];
            CRTableCDO[] arrayOfC =  new  CRTableCDO[maxDOs];

            for (int i=0; i<maxDOs; i++){
                arrayOfA[i] = CRTableADO.createVirgin(dbTrans1);
                arrayOfB[i] = CRTableBDO.createVirgin(dbTrans1);
                arrayOfC[i] = CRTableCDO.createVirgin(dbTrans1);

                arrayOfC[i].setSomedata("tableC: "+i);
                arrayOfC[i].save();

                if (null != dbTrans1)
                    dbTrans1.write();

                arrayOfB[i].setSomedata("tableB: "+i);
                arrayOfB[i].setReftoc(arrayOfC[i]);
                arrayOfB[i].save();

                arrayOfA[i].setSomedata("tableA: "+i);
                arrayOfA[i].setReftob(arrayOfB[i]);
                arrayOfA[i].save();

                if (null != dbTrans1)
                    dbTrans1.write();

                arrayOfC[i].setReftoa(arrayOfA[i]);
                arrayOfC[i].save();
            }
            if (null != dbTrans1)
                dbTrans1.commit();
            System.err.println("after insert");
            showTables(dbTrans1);
            //if (null != dbTrans1)
            //    dbTrans1.commit();

            System.err.println("signed, sealed and commited!!!");
            showTables(dbTrans1);

            /**/
            for (int i=0; i<maxDOs; i++){
                arrayOfC[i].setReftoa(null);
                arrayOfC[i].save();
             } /**/
             //if (null != dbTrans1)
             //   dbTrans1.commit();

            /**/
            for (int i=0; i<maxDOs; i++){
                arrayOfC[i].delete();
             } /**/
            if (null != dbTrans1)
                dbTrans1.commit();

            System.err.println("signed, sealed and commited!!!");
            showTables(dbTrans1);
        }catch (Exception ex){
            System.err.println(ex.toString());
            ex.printStackTrace();
        }
    }
}

