package allinone;

import com.lutris.appserver.server.sql.*;
import com.lutris.util.*;
import org.enhydra.dods.*;
import java.sql.SQLException;


import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;
import com.lutris.appserver.server.sql.*;
import allinone.data.person.*;

/**
 * The main class of DiscRack application.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class Test {
    private static final String appTitle="AllInOne DODS test";

    public static void main (String[] args) throws Throwable{
        try {
            String userDir=System.getProperty("user.dir");
            DODS.startup(userDir+File.separator+"test.conf");
        } catch (Exception ex) {
            ex.printStackTrace();
            return;
        }
        System.err.println("\n======== START ========");
        DBTransaction dbTrans = null;/*
        if (!(DODS.getDatabaseManager().getDatabaseManagerConfiguration().getAutoSave()||DODS.getDatabaseManager().getDatabaseManagerConfiguration().getAutoWrite())) {
            System.err.println("\n======== TRANSACTION: null ========");
            new CircusMultiReference().runTest(dbTrans);
            new MultiReference().runTest(dbTrans);
            new SelfReference().runTest(dbTrans);
            new MultiTransTest().runTest(dbTrans);
            System.err.println("================");
        }
                                     */
        System.err.println("\n======== TRANSACTION set ========");/**/
        dbTrans = DODS.getDatabaseManager().createTransaction();
        new CircusMultiReference().runTest(dbTrans);
        dbTrans.release();/**/
        dbTrans = DODS.getDatabaseManager().createTransaction();
        new MultiReference().runTest(dbTrans);
        dbTrans.release();/**/
        dbTrans = DODS.getDatabaseManager().createTransaction();
        new MultiReference2().runTest(dbTrans);
        dbTrans.release();
        dbTrans = DODS.getDatabaseManager().createTransaction();
        new SelfReference().runTest(dbTrans);
        dbTrans.release();
        dbTrans = DODS.getDatabaseManager().createTransaction();
        new MultiTransTest().runTest(dbTrans);
        dbTrans = DODS.getDatabaseManager().createTransaction();
        new GetDOs().runTest(dbTrans);
        dbTrans = DODS.getDatabaseManager().createTransaction();
         new MassModification().runTest(dbTrans);/**/
        System.err.println("======== FINISH ========");
        DODS.shutdown();
    }
}
